package Crawfis680;

import java.io.Console;

import Crawfis680.GraphAlgorithms.GraphTraversal;
import Crawfis680.GraphAlgorithms.SearchVisitor;
import Crawfis680.Grid.Grid;
import Crawfis680.Grid.GridDataFunction;
import Crawfis680.Grid.IGridDataAccessor;
import Crawfis680.IGraph.IGraph;

public class Program {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		//IGridDataAccessor<String> undefined = new GridDataConstantValue<String>(20,10, "Undefined");
		//IGraph<String,Object> mygraph = new Grid<String,Object>(undefined);
		IGridDataAccessor<Double> gaussian = new GridDataFunction(20,10);
		IGraph<Double,Object> mygraph = new Grid<Double,Object>(gaussian);
		int testIndex = 0;
		for(int index : mygraph.getAdjacentNodes(testIndex) ) {
			Boolean directed = !mygraph.HasEdge(index, testIndex);
			if( !directed )
				System.out.printf("Node %d is adjacent to %d with an undirected edge\n", index, testIndex);
			else
				System.out.printf("Node %d is adjacent to %d with an directed edge\n", index, testIndex);
		}
		testIndex = 19;
		for(int index : mygraph.getAdjacentNodes(testIndex) ) {
			Boolean directed = !mygraph.HasEdge(index, testIndex);
			if( !directed )
				System.out.printf("Node %d is adjacent to %d with an undirected edge\n", index, testIndex);
			else
				System.out.printf("Node %d is adjacent to %d with an directed edge\n", index, testIndex);
		}
		testIndex = 20;
		for(int index : mygraph.getAdjacentNodes(testIndex) ) {
			Boolean directed = !mygraph.HasEdge(index, testIndex);
			if( !directed )
				System.out.printf("Node %d is adjacent to %d with an undirected edge\n", index, testIndex);
			else
				System.out.printf("Node %d is adjacent to %d with an directed edge\n", index, testIndex);
		}
		testIndex = 5;
		for(int index : mygraph.getAdjacentNodes(testIndex) ) {
			Boolean directed = !mygraph.HasEdge(index, testIndex);
			if( !directed )
				System.out.printf("Node %d is adjacent to %d with an undirected edge\n", index, testIndex);
			else
				System.out.printf("Node %d is adjacent to %d with an directed edge\n", index, testIndex);
		}
		testIndex = 99;
		for(int index : mygraph.getAdjacentNodes(testIndex) ) {
			Boolean directed = !mygraph.HasEdge(index, testIndex);
			if( !directed )
				System.out.printf("Node %d is adjacent to %d with an undirected edge\n", index, testIndex);
			else
				System.out.printf("Node %d is adjacent to %d with an directed edge\n", index, testIndex);
		}
		testIndex = 198;
		for(int index : mygraph.getAdjacentNodes(testIndex) ) {
			System.out.printf("Node %d is adjacent to %d\n", index, testIndex);
		}
		testIndex = mygraph.NumberOfNodes()-1;
		for(int index : mygraph.getAdjacentNodes(testIndex) ) {
			System.out.printf("Node %d is adjacent to %d\n", index, testIndex);
		}
		testIndex = 180;
		for(int index : mygraph.getAdjacentNodes(testIndex) ) {
			Boolean directed = !mygraph.HasEdge(index, testIndex);
			if( !directed )
				System.out.printf("Node %d is adjacent to %d with an undirected edge\n", index, testIndex);
			else
				System.out.printf("Node %d is adjacent to %d with an directed edge\n", index, testIndex);
		}
		testIndex = -1;
		for(int index : mygraph.getAdjacentNodes(testIndex) ) {
			System.out.printf("Node %d is adjacent to %d\n", index, testIndex);
		}
		testIndex = mygraph.NumberOfNodes();
		for(int index : mygraph.getAdjacentNodes(testIndex) ) {
			System.out.printf("Node %d is adjacent to %d\n", index, testIndex);
		}
		
		double searchValue = 9.9;
		SearchVisitor<Double> searchVisitor = new SearchVisitor<Double>(searchValue);
		GraphTraversal<Double,Object> graphWalker = new GraphTraversal<Double,Object>(mygraph, searchVisitor);
		graphWalker.DepthFirstTraversal();
		if(searchVisitor.TargetFound())
			System.out.printf("Target found at node index %d\n", searchVisitor.TargetNodeIndex());
		System.out.printf("Search examined %d nodes\n", searchVisitor.NumberOfNodesVisited());
	}

}
